
<script>
import OrderDetails from './order-details'
import ItemOrderDetails from './item-order-detail'
import OrderLog from './order-log'
import { orderService } from '../../../services'
import config from '../../../config'
import { error_message, order_statuses } from './../../../Helper/helper'
export default {
    components : {OrderDetails, ItemOrderDetails, OrderLog},  
    props :['order-id'],
    data(){
        return {
            config:config,
            orderLoading: false,
            showModal: false,
            order: null,
            statuses: order_statuses,
            isAcceptbtnDisabled:false
        }
    },
    
    mounted(){
        this.viewDetails()
    },
    methods : {
      viewDetails(){
        this.showModal = true;
        this.orderLoading = true;
        orderService.getOrder(this.orderId)
          .then(res => {
            if(res.data.code == 200){
              this.order = res.data.result;
              this.orderLoading = false;
            }else{
              error_message(res.data.message)
              this.showModal = false
            }
          })
      },
      onModalHide(){
        this.showModal = false;
        this.$emit('hidden');
      },
      changeStatus(id,status){
        if (status == 'InKitchen') {
            this.isAcceptbtnDisabled = true;
        }
        const data = {order_id:atob(this.base64(id)),status_name:status,vendor_id:this.$auth.getClientId(),is_langauge: this.$auth.setting.primary_lang};            
        orderService.changeOrderStatus(data)
        .then(response => {
            if(response.data.code == 200){
                this.$toasted.success(response.data.msg);
            }else{
                this.$toasted.error(response.data.msg);
            }
            // if (status == 'InKitchen') {
            //     this.isAcceptbtnDisabled = false;
            // }
            this.showModal = false;
            this.$emit('actionChanged');
            this.$emit('hidden');

        })
      },
      chatuser(user_id){
        localStorage.setItem('chat_user_id',user_id);
        localStorage.setItem('chat_days','1');
        this.$router.push({ name: 'chat-list' })
      },
      checkDunzoOrder() {
          if (this.order.is_dunzo_driver == '1') {
              if (this.order.dunzo_driver) {
                  if ([this.dunzostatus.created, this.dunzostatus.queued, this.dunzostatus.runnerAccepted, this.dunzostatus.reachedForPickup].includes(this.order.dunzo_driver.status)) {
                      return true;
                  }
              } else {
                  return true;
              }
          } else if (this.order.is_dunzo_driver == '0') {
              return true;
          }
          return false;
      },      
    }
};
</script>

<template>  
  <!-- View Detail Main Start -->
  <b-modal
    v-model="showModal"
    size="lg"
    scrollable
    modal-class="order-details-main"
    title-class="font-18"
    hide-footer
    @hidden="onModalHide"
  >
    <template #modal-header="{ close }">
      <!-- Emulate built in modal header close button action -->
      <h5 class="mb-0">
        {{trans.get('__JSON__.Order No')+' '+(order && order.hash_id || '000')}}
        <span class="badge badge-pill badge-soft-primary font-size-12 ml-2" v-if="order && order.delivery_pickup_types == 'Delivery'">
          {{trans.get('__JSON__.'+order && order.delivery_pickup_types)}}
        </span>
        <span class="badge badge-pill badge-soft-danger font-size-12" v-if="order && order.delivery_pickup_types == 'Takeaway'">
          {{trans.get('__JSON__.'+order && order.delivery_pickup_types)}}
        </span>
        <span class="badge badge-pill badge-soft-danger font-size-12" v-if="order && order.delivery_pickup_types == 'Pickup'">
          {{trans.get('__JSON__.'+order && order.delivery_pickup_types)}}
        </span>
        <span class="badge badge-pill font-size-12" :class="{'badge-soft-success': order && (order.payment_method == 'Cash On Delivery'),'badge-soft-warning':order && (order.payment_method != 'Cash On Delivery')}">
              {{order && (order.payment_method == 'Cash On Delivery'?'COD':order.payment_method)}}
        </span>
        <span v-if="(order && order.order_status == 'PaymentPending') || (order && order.order_status == 'PaymentFailure')" class="badge badge-pill font-size-12"  :class="{'badge-soft-warning': (order && order.order_status == 'PaymentPending'),'badge-soft-danger':(order && order.order_status == 'PaymentFailure')}">
          {{order && order.order_status == 'PaymentPending' ? 'Pending': 'Failed'}}
        </span>
        <span class="badge badge-pill badge-soft-secondary font-size-12" v-if="order && order.access">
          <i class="bx bx-phone-call"></i> {{trans.get('__JSON__.'+order && order.access && order.access.vendor_name)}}
        </span>
        <span class="badge badge-pill badge-soft-secondary font-size-12" v-if="!$auth.partner_login">
          <a v-if="order && order.device_type == 'CALL-CENTER'">{{ order && order.device_type }}</a>
          <a v-else-if="order && order.device_type == 'Web'">{{ order && order.device_type }}</a>
          <a v-else>{{ (order && order.device_type) + ' ' + (order && order.app_version_code) }}</a>
        </span>
      
      </h5>
      <div>
        <!-- order status start -->
        <button 
            v-if="
            $auth.hasPermission(config.permissions.order_write) && 
            (order && order.order_status == statuses.placed)" 
            class="btn accept-btn"
            @click="changeStatus(order.id,statuses.inkitchen)"
            :disabled="isAcceptbtnDisabled"
            v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Confirm Order')"
            >
            <i class="fas fa-check"></i>
        </button>
        <button 
            v-if="
            $auth.hasPermission(config.permissions.order_write) && 
            (order && order.order_status == statuses.inkitchen)" 
            class="btn ready-delivery-btn"
            @click="changeStatus(order.id,statuses.readytoserve)"
            :disabled="isAcceptbtnDisabled"
            v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Ready To Delivery Order')"
            >
            <i class="fas fas fa-dolly"></i>
        </button>

        <button 
            v-if="
            $auth.hasPermission(config.permissions.order_write) && 
            (order && [statuses.readytoserve,statuses.ontheway].includes(order.order_status))" 
            class="btn accept-btn"
            @click="showModal = false, $root.$refs.order_action.deliveredOrderPopup(base64(order.id),statuses.delivered)"
            :disabled="isAcceptbtnDisabled"
            v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Deliver Order')"
            >
            <i class="fas fa-concierge-bell"></i>
        </button>

        <button 
            v-if="
            $auth.hasPermission(config.permissions.order_write) && 
            (order && [statuses.placed,statuses.inkitchen,statuses.readytoserve,statuses.ontheway,statuses.scheduled].includes(order.order_status))
            && order.is_dunzo_driver == '0'" 
            class="btn reject-btn"
            @click="showModal = false, $root.$refs.order_action.cancelOrderPopup(base64(order.id),statuses.cancelled)"
            v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Cancel Order')"
            >
            <i class="fas fa-times"></i>
        </button>
        <button 
          v-if="
          $auth.hasPermission(config.permissions.order_write) && 
          (order && [statuses.placed,statuses.inkitchen,statuses.readytoserve,statuses.ontheway,statuses.scheduled].includes(order.order_status))
          && order.is_dunzo_driver == '1' && checkDunzoOrder()" 
          class="btn reject-btn"
          @click="showModal = false, $root.$refs.order_action.cancelOrderPopup(base64(order.id),statuses.cancelled)"
          v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Cancel Order')"
          >
          <i class="fas fa-times"></i>
        </button>
        <!-- order status end -->
          <!-- chat start -->

          <!-- <button 
            v-if="!$auth.partner_login"
            class="print-btn btn"
            @click="chatuser(order.user.user_id)"
            v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Chat')"
            >
            <i class="bx bx-chat font-size-15"></i>
          </button> -->
        <!-- chat end -->
        
        <a class="print-btn btn" v-if="$auth.partner_login" v-b-tooltip.hover.v-light :title="trans.get('__JSON__.A4')" :href="config.appurl+'store-print-order-new/'+base64(order && order.id+','+$auth.getClientId())" target="_blank"><i class="mdi mdi-printer font-size-15"></i></a>
        <a class="print-btn btn" v-else v-b-tooltip.hover.v-light :title="trans.get('__JSON__.A4')" :href="config.appurl+'print-order-new/'+base64(order && order.id+','+$auth.getClientId())" target="_blank"><i class="mdi mdi-printer font-size-15"></i></a>

        <a class="print-btn btn" v-if="$auth.partner_login" v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Thermal Print')" :href="config.appurl+'store-print-order/'+base64(order && order.id+','+$auth.getClientId())" target="_blank"><i class="mdi mdi-printer font-size-15"></i></a>
        <a class="print-btn btn" v-else v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Thermal Print')" :href="config.appurl+'print-order/'+base64(order && order.id+','+$auth.getClientId())" target="_blank"><i class="mdi mdi-printer font-size-15"></i></a>
        <button @click="close()" class="close">
          <i class="fas fa-times"></i>
        </button>
      </div>
    </template>
    <b-tabs
      justified
      nav-class="nav-tabs-custom mt-0 order-tabs"
      content-class="text-muted"
    >
      <b-tab active>
        <template v-slot:title>
          <span class="d-inline-block d-sm-none">
            <i class="fas fa-receipt"></i>
          </span>
          <span class="d-none d-sm-inline-block">{{trans.get('__JSON__.Order Details')}}</span
          >
        </template>
        <order-details :order="order" :loading="orderLoading" /> 
      </b-tab>
      <b-tab >
        <template v-slot:title>
          <span class="d-inline-block d-sm-none">
            <i class="fas fa-list-ul"></i>
          </span>
          <span class="d-none d-sm-inline-block">{{trans.get('__JSON__.Order Item Details')}}</span>
        </template>
        <item-order-details :order="order" :loading="orderLoading" /> 
      </b-tab>
      <b-tab v-if="order && order.order_status != 'PaymentPending'">
        <template v-slot:title>
          <span class="d-inline-block d-sm-none">
            <i class="fas fa-list-ul"></i>
          </span>
          <span class="d-none d-sm-inline-block">{{trans.get('__JSON__.Order Log')}}</span>
        </template>
        <order-log :order="order" :loading="orderLoading" /> 
      </b-tab>
    </b-tabs>
  </b-modal>
</template>


<style>
.print-btn {
  padding: 0px;
  color: #556ee6;
  border-radius: 50%;
  border: 1px solid #556ee6;
  height: 35px;
  width: 35px;
  line-height: 35px;
  text-align: center;
}
.print-btn:hover {
  color: #556ee6;
}
button.close {
  position: relative;
  top: 8px;
}
</style>
<style  scoped>
.accept-btn, .reject-btn {
    color: #fff;
    font-size: 16px;
    font-weight: 100;
    line-height: 0;
    border-radius: 50%;
}
.accept-btn {
    background-color: #34c38f;
    padding: 10px;
    padding: 0px;
    border-radius: 50%;
    height: 35px;
    width: 35px;
    line-height: 35px;
    text-align: center;
}
.reject-btn {
    background-color: #f46a6a;
    padding: 5px 7px 5px 7px;
}
.ready-delivery-btn {
    background-color: #de6839;
    padding: 10px;
    padding: 0px;
    border-radius: 50%;
    height: 35px;
    width: 35px;
    line-height: 35px;
    text-align: center;
    color: white;
}
.reject-btn {
    background-color: #f46a6a;
    padding: 10px;
    padding: 0px;
    border-radius: 50%;
    height: 35px;
    width: 35px;
    line-height: 35px;
    text-align: center;
    color: white;
}
.order-option-dropdown button {
    padding: 0;
}
</style>